<?php

function plugin_catalogue_periodiques_calcule_prochaine_date ($parametres) {

// contre le passage à l'heure d'hivers car cela pose problème lorsqu'on ajoute une journée (24*60*60) à cette date
// Dans ce cas, la date ne correspond pas en octobre lors du passage à l'heure d'hivers
// On reste le même jour car il faut encore une heure => bouclage infini
    $timezoneserver=date_default_timezone_get();
    date_default_timezone_set('UTC');

// 1) remplir par défaut le retour
    $retour=array();
    $retour["succes"]=1;
    $retour["resultat"]=array();
    $retour["resultat"]["date"]=date("Y-m-d"); // valeur du jour par dfaut
    $retour["resultat"]["joursemaine"]=date("N");
    $timestamp_prochain_no=time();

// 2) récupérer les paramètres
    $date_dernier_no=$parametres["date_dernier_no"];
    $parait_jours=$parametres["parait_jours"];
    $parait_mois=$parametres["parait_mois"];
    $mode_parution=$parametres["mode_parution"];
    
    $liste_jours=explode ("|", $parait_jours);
    $liste_mois=explode ("|", $parait_mois);
    if ($parait_jours == "") {
        $liste_jours=array(1,2,3,4,5,6,7);
    }
    if ($parait_mois == "") {
        $liste_mois=array(1,2,3,4,5,6,7,8,9,10,11,12);
    }

// 3) on convertit la date en timestamp
    $tmp=explode("-", $date_dernier_no);
    if (count($tmp) != 3) {
        print ("pas de date donnée\n");
        date_default_timezone_set($timezoneserver);
        return ($retour);
    }
    $annee_dernier_no=$tmp[0];
    $mois_dernier_no=$tmp[1];
    $jour_dernier_no=$tmp[2];
    $timestamp_dernier_no=mktime(0, 0 ,0, $mois_dernier_no, $jour_dernier_no, $annee_dernier_no);
    $jour_semaine_dernier_no=date("N", $timestamp_dernier_no);

// 4) traiter chaque mode
// *********************************************************************************
    if ($mode_parution == "IRRE") {
// nbs jours par mois
     $liste_jourmois=array(31,28,31,30,31,30,31,31,30,31,30,31);
     if ($mois_dernier_no == 12) {
      $mois_prochain_no=1;
      $annee_prochain_no=$annee_dernier_no+1;
     } else {
      $mois_prochain_no=$mois_dernier_no+1;
      $annee_prochain_no=$annee_dernier_no;
     }
     if ($liste_jourmois[$mois_prochain_no-1] < $jour_dernier_no) {
      $jour_prochain_no=$liste_jourmois[$mois_prochain_no-1];
     } else {
      $jour_prochain_no=$jour_dernier_no;
     }
     $timestamp_prochain_no=mktime(0, 0 ,0, $mois_prochain_no, $jour_prochain_no, $annee_prochain_no);

// *********************************************************************************
    } elseif ($mode_parution == "BIMENS1-15") {
// passer à la seconde quinzaine
     if ($jour_dernier_no < 15) {
        $timestamp_prochain_no=mktime(0, 0 ,0, $mois_dernier_no, 15, $annee_dernier_no);
     } else {
// recherche du mois suivant valide d'après liste des mois acceptés
      if (count($liste_mois) == 1) {
       $mois_prochain_no=$liste_mois[0];
       $annee_prochain_no=$annee_dernier_no+1;
      } else {
// on ajoute le premier mois à la fin de la liste pour bouclage
       $liste_mois[count($liste_mois)]= $liste_mois[0];
       for ($i=0;$i<=count($liste_mois)-1;$i++) {
         $mois_prochain_no=$liste_mois[$i];
        if ( "$mois_dernier_no" == "$liste_mois[$i]" ) {
         $mois_prochain_no=$liste_mois[$i+1];
         break ;
        } elseif ( "$mois_dernier_no" < "$liste_mois[$i]" ) {
         break ;
        }
       }
// on passe à l'année suivante si nécessaire et on se positionne au premier jour du mois
       if ( "$mois_dernier_no" > "$mois_prochain_no" ) {
        $annee_prochain_no=$annee_dernier_no+1;
       } else {
        $annee_prochain_no=$annee_dernier_no;
       }
      }
      $timestamp_prochain_no=mktime(0, 0 ,0, $mois_prochain_no, 1, $annee_prochain_no);
    }

// *********************************************************************************
    } elseif ($mode_parution == "MENS") {
// on désactive la liste des jours de la semaine car on prend le jour de la date d'entrée
//     $liste_jours=array(1,2,3,4,5,6,7);
     if (count($liste_jours) == 1) {
      $jour_semaine_dernier_no=$liste_jours[0];
     } else {
// on ajoute le premier jour de la semaine à la fin de la liste pour bouclage
      $liste_jours[count($liste_jours)]= $liste_jours[0];
      $idx=count($liste_jours)-1;
      for ($i=0;$i<=count($liste_jours)-1;$i++) {
       if ( $jour_semaine_dernier_no == $liste_jours[$i] ) {
        $idx=$i;
        break ;
       } elseif ( $jour_semaine_dernier_no < $liste_mois[$i] ) {
        $idx=$i;
        break ;
       }
      }
      $jour_semaine_dernier_no=$liste_jours[$idx];
     }
// recherche du mois suivant valide d'après liste des mois acceptés
     if (count($liste_mois) == 1) {
      $mois_prochain_no=$liste_mois[0];
      $annee_prochain_no=$annee_dernier_no+1;
     } else {
// on ajoute le premier mois à la fin de la liste pour bouclage
      $liste_mois[count($liste_mois)]= $liste_mois[0];
      for ($i=0;$i<=count($liste_mois)-1;$i++) {
       $mois_prochain_no=$liste_mois[$i];
       if ( "$mois_dernier_no" == "$liste_mois[$i]" ) {
        $mois_prochain_no=$liste_mois[$i+1];
        break ;
       } elseif ( "$mois_dernier_no" < "$liste_mois[$i]" ) {
        break ;
       }
      }
// on passe à l'année suivante si nécessaire et on se positionne au premier jour du mois
      if ( "$mois_dernier_no" > "$mois_prochain_no" ) {
       $annee_prochain_no=$annee_dernier_no+1;
      } else {
       $annee_prochain_no=$annee_dernier_no;
      }
     }
// calcul n° de semaine (0 à 4)
     $facteur= (int) (($jour_dernier_no-1)/7);

// pour la 5ème semaine, la date est mise en fin de mois ou cas du 28 février
     if ($mois_dernier_no == 2 and $jour_dernier_no == 28) {
// année bissextile ?
      $travail=mktime(0, 0 ,0, $mois_dernier_no, $jour_dernier_no, $annee_dernier_no)+24*60*60;
      $travailm=date("m", $travail);
// si 1 mars
      if ( $travailm == 3) {
       $facteur=4;
      }
     }

     if ($facteur == 4) {
      $mois_prochain_no++;
      if ($mois_prochain_no == 12) {
       $mois_prochain_no=1;
       $annee_prochain_no++;
      }
      $timestamp_prochain_no=mktime(0, 0 ,0, $mois_prochain_no, 1, $annee_prochain_no)-24*60*60;
     } else {
// calcul n° de semaine (0 à 4)
      $jour_prochain_no=1+$facteur*7;

      $timestamp_prochain_no=mktime(0, 0 ,0, $mois_prochain_no, $jour_prochain_no, $annee_prochain_no);
      $jour_semaine_prochain_no=date("N", $timestamp_prochain_no); // de 1  7 sans "0"
      $idx=0;
      while ( $jour_semaine_prochain_no != $jour_semaine_dernier_no ) {
        $idx++;
        $timestamp_prochain_no+=60*60*24;//on rajoute un jour
        $jour_semaine_prochain_no=date("N", $timestamp_prochain_no); // de 1  7 sans "0"
      }
     }

// *********************************************************************************
    } elseif ($mode_parution == "BIMENSUEL") {
     if (count($liste_jours) == 1) {
      $jour_semaine_dernier_no=$liste_jours[0];
     } else {
// on ajoute le premier jour de la semaine à la fin de la liste pour bouclage
      $liste_jours[count($liste_jours)]= $liste_jours[0];
      $idx=count($liste_jours)-1;
      for ($i=0;$i<=count($liste_jours)-1;$i++) {
       if ( $jour_semaine_dernier_no == $liste_jours[$i] ) {
        $idx=$i;
        break ;
       } elseif ( $jour_semaine_dernier_no < $liste_mois[$i] ) {
        $idx=$i;
        break ;
       }
      }
      $jour_semaine_dernier_no=$liste_jours[$idx];
     }
// calcul n° de semaine (0 à 4)
     $facteur= (int) (($jour_dernier_no-1)/7);
     if ($facteur == 4) {
      $facteur=3;
     }

     if ($facteur < 2) {
      $facteur=$facteur+2;
      $mois_prochain_no=$mois_dernier_no;
      $annee_prochain_no=$annee_dernier_no;
      $jour_prochain_no=1+$facteur*7;
     } else {
      $facteur=$facteur-2;
      $jour_prochain_no=1+$facteur*7;
      if (count($liste_mois) == 1) {
       $mois_prochain_no=$liste_mois[0];
       $annee_prochain_no=$annee_dernier_no+1;
      } else {
// on ajoute le premier mois à la fin de la liste pour bouclage
       $liste_mois[count($liste_mois)]= $liste_mois[0];
       for ($i=0;$i<=count($liste_mois)-1;$i++) {
        $mois_prochain_no=$liste_mois[$i];
        if ( "$mois_dernier_no" == "$liste_mois[$i]" ) {
         $mois_prochain_no=$liste_mois[$i+1];
         break ;
        } elseif ( "$mois_dernier_no" < "$liste_mois[$i]" ) {
         break ;
        }
       }
// on passe à l'année suivante si nécessaire et on se positionne au premier jour du mois
       if ( "$mois_dernier_no" > "$mois_prochain_no" ) {
        $annee_prochain_no=$annee_dernier_no+1;
       } else {
        $annee_prochain_no=$annee_dernier_no;
       }
      }
     }
     $timestamp_prochain_no=mktime(0, 0 ,0, $mois_prochain_no, $jour_prochain_no, $annee_prochain_no);
     $jour_semaine_prochain_no=date("N", $timestamp_prochain_no); // de 1  7 sans "0"
     $idx=0;
     while ( $jour_semaine_prochain_no != $jour_semaine_dernier_no ) {
        $idx++;
        $timestamp_prochain_no+=60*60*24;//on rajoute un jour
        $jour_semaine_prochain_no=date("N", $timestamp_prochain_no); // de 1  7 sans "0"
     }

// *********************************************************************************
    } elseif ($mode_parution == "HEBD" OR $mode_parution == "BIMENS") {

     if ($mode_parution == "HEBD") {
      $delais=7*60*60*24;//on rajoute 7 jours
     } elseif ($mode_parution == "BIMENS") {
      $delais=2*7*60*60*24;//on rajoute 14 jours
     }

     if (count($liste_jours) == 1) {
      $jour_semaine_dernier_no=$liste_jours[0];
     } else {
// on ajoute le premier jour de la semaine à la fin de la liste pour bouclage
      $liste_jours[count($liste_jours)]= $liste_jours[0];
      $idx=count($liste_jours)-1;
      for ($i=0;$i<=count($liste_jours)-1;$i++) {
       if ( $jour_semaine_dernier_no == $liste_jours[$i] ) {
        $idx=$i;
        break ;
       } elseif ( $jour_semaine_dernier_no < $liste_mois[$i] ) {
        $idx=$i;
        break ;
       }
      }
      $jour_semaine_dernier_no=$liste_jours[$idx];
     }
     $timestamp_prochain_no=$timestamp_dernier_no+$delais;
     $jour_semaine_prochain_no=date("N", $timestamp_prochain_no); // de 1  7 sans "0"
     $idx=0;
     while ( $jour_semaine_prochain_no != $jour_semaine_dernier_no ) {
        $idx++;
        $timestamp_prochain_no+=60*60*24;//on rajoute un jour
        $jour_semaine_prochain_no=date("N", $timestamp_prochain_no); // de 1  7 sans "0"
     }

     while (in_array(date("m",$timestamp_prochain_no),$liste_mois) == false) {
      $timestamp_prochain_no=$timestamp_prochain_no+$delais;
     }

// *********************************************************************************
    } elseif ($mode_parution == "QUOT") {
     $delais=60*60*24;//on rajoute 1 jour
     $timestamp_prochain_no=$timestamp_dernier_no+$delais;

     while (0 == 0) {

      while (in_array(date("N",$timestamp_prochain_no),$liste_jours) == false) {
       $timestamp_prochain_no+=60*60*24;//on rajoute un jour
      }

      if (in_array(date("m",$timestamp_prochain_no),$liste_mois) == true) {
       break;
      } else {
       while (in_array(date("m",$timestamp_prochain_no),$liste_mois) == false) {
        $mois_prochain_no=date("m",$timestamp_prochain_no);
        $annee_prochain_no=date("Y",$timestamp_prochain_no);
        $mois_prochain_no++;
        if ( $mois_prochain_no > 12 ) {
         $mois_prochain_no=1;
         $annee_prochain_no++;
        }
        $timestamp_prochain_no=mktime(0, 0 ,0, $mois_prochain_no, 1 , $annee_prochain_no);
       }
      }
     }

// *********************************************************************************
    } else {
     print ("pas de mode donné\n");
    }
// *********************************************************************************

 $retour["resultat"]["date"]=date("Y-m-d", $timestamp_prochain_no);  
 $retour["resultat"]["joursemaine"]=date("N", $timestamp_prochain_no);
 date_default_timezone_set($timezoneserver);
 return ($retour);

}

?>
