<?php

// ADB

// situé dans le répertoire: waterbear/include/plugins/div


/**
 * plugin_div_mc_redirect()
 * 
 * Ce plugin permet de rediriger vers un un menu contextuel en fonction de certaines caratristiques de la notice
 * 
 * paramtres ID : ID_notice
 * paramtres registre :
 * type_obj => type de l'objet
 * plugin_formate => plugin utilis pour rcuprer l'info
 * choix [val1, val2, val3,..., _else][nom_plugin OU plugin_formate|choix] : liste des valeurs possibles. A chaque valeur on associe SOIT
 *       un nom de plugin SOIT (de manire rcursive) une nouvelle valeur  tester. la Clef _else permet de mettre une valeur par dfaut 
 *
 * Ce plugin retourne le menu contextuel recherch
 * 
 */
function plugin_div_mc_redirect ($parametres) {

$plugin_formate=$parametres["plugin_formate"];
$choix=$parametres["choix"];
$type_obj=$parametres["type_obj"];
$ID_notice=$parametres["ID"];

// 1) on rcupre la notice
$notice=get_objet_xml_by_id($type_obj, $ID_notice);
if ($notice == "") {
    $erreur="la notice de type $type_obj ayant l'ID $ID_notice n'existe pas";
}

$nom_plugin=plugin_mc_redirect_analyse_choix($notice, $plugin_formate, $choix);
if (!is_array($nom_plugin)) {
    $erreur="impossible de determiner la grille a utiliser : $nom_plugin";
} 

// on rcupre le menu contextuel
    $plugin=array();
    $plugin["nom_plugin"]=$nom_plugin['nom_plugin'];
    $plugin["parametres"]=array("type_obj"=>$type_obj, "ID"=>$ID_notice);
    $retour=applique_plugin($plugin, array());

    return ($retour);
}


////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
function plugin_mc_redirect_analyse_choix ($notice, $plugin_formate, $choix) {
    
    
    // 1) on formate la chaine
    $tmp=applique_plugin($plugin_formate, array("notice"=>$notice));
    if ($tmp["succes"] != 1) {
        return("Erreur lors du formatage : ".$tmp["erreur"]);
    }
    $chaine=$tmp["resultat"]["texte"];
    
    // on rcupre les valeurs correspondant  cette chaine
    if (isset($choix[$chaine])) {
        $resultat=$choix[$chaine];
    } elseif (isset($choix["_else"])) {
        $resultat=$choix["_else"];
    } else {
        return("aucune valeur parametree");
    }
    
    // on regarde s'il y a des sous-valeurs
    if (isset($resultat["plugin_formate"])) {
        $resultat2=plugin_mc_redirect_analyse_choix ($notice, $resultat["plugin_formate"], $resultat["choix"]);
        return($resultat2);
    } else {
        return ($resultat);
    }
}


?>